Legrand / Raritan / Server Technology Xerus™ JSON-RPC API: cert::ServerSSLCert Interface Reference

Legrand / Raritan / Server Technology Xerus™ JSON-RPC API

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
cert::ServerSSLCert Interface Reference

TLS certificate management interface. More...

## Classes
struct | CertInfo
| Certificate information. More...
struct | CommonAttributes
| Certificate issuer or subject attributes. More...
struct | Info
| Certificate manager information. More...
struct | ReqInfo
| Certificate signing request information. More...

## Public Types
enum | KeyType { KEY_TYPE_UNKNOWN , KEY_TYPE_RSA , KEY_TYPE_ECDSA }
| Supported key types. More...
enum | EllipticCurve { EC_CURVE_UNKNOWN , EC_CURVE_NIST_P256 , EC_CURVE_NIST_P384 , EC_CURVE_NIST_P521 }
| Supported elliptic curves for key type ECDSA. More...

## Public Member Functions
int | generateUnsignedKeyPair (in ReqInfo reqInfo, in string challenge)
| Generate an unsigned key pair. More...
int | generateSelfSignedKeyPair (in ReqInfo reqInfo, in int days)
| Generate a self-signed key pair. More...
void | deletePending ()
| Remove a pending certificate signing request or certificate.
void | getInfo (out Info info)
| Retrieve certificate manager information. More...
int | installPendingKeyPair ()
| Activate a pending key pair. More...

## Public Attributes
constant int | SUCCESS = 0
| success code
constant int | ERR_GEN_KEY_LEN_INVALID = 100
| key-pair generation error codes
constant int | ERR_GEN_CSR_OR_CERT_PENDING = 101
constant int | ERR_GEN_KEY_GEN_FAILED = 102
constant int | ERR_GEN_KEY_TYPE_INVALID = 103
constant int | ERR_GEN_ELLIPTIC_CURVE_INVALID = 104
constant int | ERR_INSTALL_KEY_MISSING = 200
| key-pair installation error codes
constant int | ERR_INSTALL_CERT_MISSING = 201
constant int | ERR_INSTALL_CERT_FORMAT_INVALID = 202
constant int | ERR_INSTALL_CERT_KEY_MISMATCH = 203
constant int | ERR_INSTALL_KEY_FORMAT_INVALID = 204

## Detailed Description

TLS certificate management interface.

## Member Enumeration Documentation

## ◆ EllipticCurve

enum cert::ServerSSLCert::EllipticCurve

Supported elliptic curves for key type ECDSA.

Enumerator
EC_CURVE_UNKNOWN | Curve unknown (only allowed as return value)
EC_CURVE_NIST_P256 | NIST curve P-256 (also known as secp256r1 and prime256v1)
EC_CURVE_NIST_P384 | NIST curve P-384 (also known as secp384r1)
EC_CURVE_NIST_P521 | NIST curve P-521 (also known as secp521r1)

## ◆ KeyType

enum cert::ServerSSLCert::KeyType

Supported key types.

Enumerator
KEY_TYPE_UNKNOWN | Key type unknown (only allowed as return value)
KEY_TYPE_RSA | RSA key.
KEY_TYPE_ECDSA | ECDSA key.

## Member Function Documentation

## ◆ generateSelfSignedKeyPair()

int cert::ServerSSLCert::generateSelfSignedKeyPair | ( | in ReqInfo | reqInfo,
|  | in int | days
| ) |  |

Generate a self-signed key pair.

Parameters

  reqInfo | Certificate signing request information
  days | Number of days the certificate will be valid

Returns
  SUCCESS or one of the error code constants

## ◆ generateUnsignedKeyPair()

int cert::ServerSSLCert::generateUnsignedKeyPair | ( | in ReqInfo | reqInfo,
|  | in string | challenge
| ) |  |

Generate an unsigned key pair.

Parameters

  reqInfo | Certificate signing request information
  challenge | Challenge password

Returns
  SUCCESS or one of the error code constants

## ◆ getInfo()

void cert::ServerSSLCert::getInfo | ( | out Info | info | ) |

Retrieve certificate manager information.

Parameters

  info | Result: Certificate manager information

## ◆ installPendingKeyPair()

int cert::ServerSSLCert::installPendingKeyPair | ( |  | ) |

Activate a pending key pair.

Returns
  SUCCESS or one of the error code constants

The documentation for this interface was generated from the following file:

- ServerSSLCert.idl